package cashmachine.model;

import java.util.Collections;
import java.util.List;

public class Account
{
	private final int accountId;
	private final int pin;
	private final int balance;
	private final int limit;
	private final List<Integer> authorizedAccountIds;

	public Account(int accountId, int pin, int balance, int limit, List<Integer> authorizedAccountIds) {
		this.accountId = accountId;
		this.pin = pin;
		this.balance = balance;
		this.limit = limit;
		this.authorizedAccountIds = Collections.unmodifiableList(authorizedAccountIds);
	}

	public int getAccountId() {
		return accountId;
	}

	public int getPin() {
		return pin;
	}

	public int getBalance() {
		return balance;
	}

	public int getLimit() {
		return limit;
	}

	public List<Integer> getAuthorizedAccountIds() {
		return authorizedAccountIds;
	}

	public boolean isAuthorizedToSign(int accountId) {
		return this.accountId == accountId
				|| authorizedAccountIds.contains(accountId);
	}
}
